// JavaScript doesn't have actual constants or finals, but these things
// in all caps are constants and should never be changed in the code.

// The width and height here match what's specified in the #front in the CSS
var VISIBLE_AREA_WIDTH  = 295;
var VISIBLE_AREA_HEIGHT = 385;

var TEXT_AREA_BOTTOM = VISIBLE_AREA_HEIGHT - 30;
var RATINGS_KEY_HEIGHT = 0;
var MAX_URL_CHARS_PER_WIDTH = Math.floor(VISIBLE_AREA_WIDTH / 6);

var TIMEOUT_MILLIS = 50;

//var LEFT_DROP_DOWN_IMAGE_WIDTH  = 20;
//var RIGHT_DROP_DOWN_IMAGE_WIDTH = 20;
var DROP_DOWN_IMAGE_SIDES_WIDTH = 40;

//var BASE_URL = "http://www.profster.com/";
var BASE_URL = "http://www.restaurantratingz.com/";

var WIDGET_STATE_LIST_JSP  = "local/widgetStateList.jsp";
var WIDGET_CITY_LIST_JSP   = "local/widgetCityList.jsp";
var WIDGET_REST_LIST_JSP   = "local/widgetRestList.jsp";
var WIDGET_RATING_INFO_JSP = "local/widgetRatingInfo.jsp";

var SHOW_RATINGS_JSP = "ShowRatings.jsp";
var ADD_RATING_JSP   = "AddRating.jsp";

var RATINGS_CAT_LABELS = new Array("Food", "Ambience", "Service");

var GREEN_BKG_COLOR = "#A8D578";

var req;

function loaded() {
    scrollerInit(document.getElementById('myScrollBar'),
                 document.getElementById('myScrollTrack'),
                 document.getElementById('myScrollThumb'));

    document.getElementById("innerTable").setAttribute("bgcolor", GREEN_BKG_COLOR);

    getStateList();
}

function getStateList() {
    req = new XMLHttpRequest();
    req.open("GET", BASE_URL + WIDGET_STATE_LIST_JSP, false);
    req.setRequestHeader("Cache-Control", "no-cache");
    req.onreadystatechange = buildStateSelect;
    req.send(null);
}

function buildStateSelect() {
    if (req.readyState == 4) {
        buildSelectMenu("states", "Select your state", "state");
    /*
        var stateSelect = document.getElementById("states");
        appendToSelect(stateSelect, 0, "Select your state");
        var states = req.responseXML.getElementsByTagName("state");
        for (var idx = 0; idx < states.length; idx++) {
            var state = states.item(idx);
            var idAttr = state.getAttribute("id");
            var refAttr = state.getAttribute("ref");
            appendToSelect(stateSelect, idAttr, refAttr);
        }
    */
    }
}

function checkStatesList(event) {
    var selectObj = event.target;

    if (selectObj.options.length == 1) {
        getStateList();
    }
}

function getCityList(event) {
    var selectObj = event.target;

    if (selectObj.selectedIndex == 0) {
        return;
    }

    var selectedOption = selectObj.options[selectObj.selectedIndex];

    document.getElementById('statesLabel').innerHTML = selectedOption.innerHTML;

    hideElement("divCities");
    hideElement("divRestaurants");
    clearRestaurantInfo();

    showWait();

    req = new XMLHttpRequest();
    req.open("GET", BASE_URL + WIDGET_CITY_LIST_JSP + "?tcvid=" + selectedOption.value + "&noredirect=1", false);
    req.setRequestHeader("Cache-Control", "no-cache");
    req.onreadystatechange = buildCitySelect;

    // The extra complexity here of using setTimeout rather than just
    // calling req.send directly, is needed to insert a slight delay
    // so that the call to showWait() above has time to actually update
    // the screen.
    setTimeout('sendCityListGet()', TIMEOUT_MILLIS);
}

function sendCityListGet() {
    req.send(null);
}

function buildCitySelect() {
    if (req.readyState != 4) {
        return;
    }

    try {
        buildSelectMenu("cities", "Select a city", "city");

        showElement("divCities");

        var citiesBackground = document.getElementById("citiesBackground");
        var citiesMiddle = document.getElementById("citiesBkgMiddle");
        var citiesSelect = document.getElementById("cities");

        // citiesBackground is the div that contains the images for the custom drop-down.
        // citiesSelect is the actual select control that, even  though hidden, resizes itself
        // according to its menu contents. So here we set the size of the div to the size of
        // the select, then set the size of the middle image to the total size minus the sizes
        // of the end images (which are of fixed size).
        citiesBackground.style.width = "" + citiesSelect.offsetWidth + "px";
        citiesMiddle.style.width = "" + (citiesSelect.offsetWidth - DROP_DOWN_IMAGE_SIDES_WIDTH) + "px";

        document.getElementById('citiesLabel').innerHTML = citiesSelect.options[citiesSelect.selectedIndex].innerHTML;
    } catch (err) {
    }

    hideWait();
}

function getRestaurantList(event) {
    var selectObj = event.target;

    if (selectObj.selectedIndex == 0) {
        return;
    }

    var selectedOption = selectObj.options[selectObj.selectedIndex];

    document.getElementById('citiesLabel').innerHTML = selectedOption.innerHTML;

    hideElement("divRestaurants");
    clearRestaurantInfo();

    showWait();

    req = new XMLHttpRequest();
    req.open("GET", BASE_URL + WIDGET_REST_LIST_JSP + "?tcvid=" + selectedOption.value + "&numrows=1000", false);
    req.setRequestHeader("Cache-Control", "no-cache");
    req.onreadystatechange = buildRestaurantSelect;

    setTimeout('sendRestaurantListGet()', TIMEOUT_MILLIS);
}

function sendRestaurantListGet() {
    req.send(null);
}

function buildRestaurantSelect() {
    if (req.readyState != 4) {
        return;
    }

    try {
        buildSelectMenu("restaurants", "Select a restaurant", "restaurant");

        showElement("divRestaurants");

        var restaurantsBackground = document.getElementById("restaurantsBackground");
        var restaurantsMiddle = document.getElementById("restaurantsBkgMiddle");
        var restaurantsSelect = document.getElementById("restaurants");

        // See the comment for resizing the citiesBackground above.
        restaurantsBackground.style.width = "" + restaurantsSelect.offsetWidth + "px";
        restaurantsMiddle.style.width = "" + (restaurantsSelect.offsetWidth - DROP_DOWN_IMAGE_SIDES_WIDTH) + "px";

        document.getElementById('restaurantsLabel').innerHTML = restaurantsSelect.options[restaurantsSelect.selectedIndex].innerHTML;
    } catch (err) {
    }

    hideWait();
}

function showElement(elName) {
    document.getElementById(elName).style.display = "block";
}

function hideElement(elName) {
    document.getElementById(elName).style.display = "none";
}

function showWait() {
    document.getElementById("pleaseWait").style.display = "block";
}

function hideWait() {
    document.getElementById("pleaseWait").style.display = "none";
}

function clearRestaurantInfo() {
    hideElement("ratingInfo");

    var infoTable = document.getElementById("infoTable");
    clearTable(infoTable);

    var commentsTable = document.getElementById("commentsTable");
    clearTable(commentsTable);

    hideScrollBar();
}

function clearSelectList(select) {
    while (select.length > 0) {
        select.remove(0);
    }
}

// Create and append a new <option> tag to the specified <select>
// The content parameter is expected to be a string.
function appendToSelect(select, value, content) {
    var opt = document.createElement("option");
    opt.value = value;
    opt.innerHTML = content;
    select.appendChild(opt);
}

function buildSelectMenu(selectName, firstLine, xmlElementName) {
    var select = document.getElementById(selectName);
    clearSelectList(select);
    appendToSelect(select, 0, firstLine);

    var elementList = req.responseXML.getElementsByTagName(xmlElementName);

    for (var idx = 0; idx < elementList.length; idx++) {
        var element = elementList.item(idx);
        var idAttr = element.getAttribute("id");
        var nameNode = element.getElementsByTagName("name").item(0);
        var nameText = nameNode.firstChild.nodeValue;

        appendToSelect(select, idAttr, nameText);
        //for debugging: appendToSelect(select, idAttr, nameText + " " + idAttr);
    }

    //select.style.display = "block";
}

function clearTable(tableNode) {
    var oneRow = tableNode.getElementsByTagName("TR").item(0);
    while (oneRow != null) {
        tableNode.removeChild(oneRow);
        oneRow = tableNode.getElementsByTagName("TR").item(0);
    }
}

function getRestaurantInfo(event) {
    var selectObj = event.target;

    if (selectObj.selectedIndex == 0) {
        return;
    }

    var selectedOption = selectObj.options[selectObj.selectedIndex];

    document.getElementById('restaurantsLabel').innerHTML = selectedOption.innerHTML;

    showWait();

    req = new XMLHttpRequest();
    req.open("GET", BASE_URL + WIDGET_RATING_INFO_JSP + "?tcvid=" + selectedOption.value + "&noredirect=1", false);
    req.setRequestHeader("Cache-Control", "no-cache");
    req.onreadystatechange = showRestaurantInfo;

    setTimeout('sendRestaurantInfoGet()', TIMEOUT_MILLIS);
}

function sendRestaurantInfoGet() {
    req.send(null);
}

function showRestaurantInfo() {
    if (req.readyState != 4) {
        return;
    }

    try {
        resetScrollBar();

        buildRatingTable();

        buildInfoTable();

        // Set the top and height of the detail area and scroll bar

        var hRule = document.getElementById("horizRule");
        var hRuleYPos = findPosY(hRule);
        document.getElementById("commentsParent").style.height =
            "" + (TEXT_AREA_BOTTOM - (hRuleYPos + RATINGS_KEY_HEIGHT)) + "px";

        var scrollBar = document.getElementById("myScrollBar");
        scrollBar.style.height = commentsParent.style.height;
        scrollBar.style.top = "" + (hRuleYPos + 10 + RATINGS_KEY_HEIGHT) + "px";

        buildCommentsTable();
    } catch (err) {
    }

    hideWait();

    calculateAndShowThumb(document.getElementById('divComments'));
}

function buildRatingTable() {
    var restaurantId = req.responseXML.getElementsByTagName("restaurant").item(0).getAttribute("id");

    document.getElementById("numRatingsValue").innerText = req.responseXML.getElementsByTagName("numRatings").item(0).firstChild.nodeValue;
    document.getElementById("avgRatingValue").innerText = req.responseXML.getElementsByTagName("avgRating").item(0).firstChild.nodeValue;

    var smileyUrlText = req.responseXML.getElementsByTagName("smileyUrl").item(0).firstChild.nodeValue;
    document.getElementById("ratingSmileyImage").setAttribute("src", smileyUrlText);

    document.getElementById("rateThisRestLink").setAttribute("onClick", "widget.openURL('" + BASE_URL + ADD_RATING_JSP + "?tcvid=" + restaurantId + "');return false;");

    showElement("ratingInfo");
}

function buildInfoTable() {
    var row;
    var cell;
    var textNode;
    var aTag;
    var elementList;
    var element;
    var idx;
    var nameText;
    var valueNode;
    var valueText;
    var websiteUrl;
    var websiteText;

    var infoTable = document.getElementById("infoTable");
    clearTable(infoTable);

    var cuisineText = getNodeText("cuisine");

    if (cuisineText != null) {
        row = document.createElement("TR");

        cell = document.createElement("TD");
        cell.setAttribute("width", "40%");
        cell.setAttribute("align", "right");
        cell.setAttribute("class", "rating");
        textNode = document.createTextNode("Cuisine:");
        cell.appendChild(textNode);
        row.appendChild(cell);

        cell = document.createElement("TD");
        //textNode = document.createTextNode("&nbsp;" + cuisineText);
        //cell.appendChild(textNode);
        cell.innerHTML = "&nbsp;" + cuisineText;
        row.appendChild(cell);

        infoTable.appendChild(row);
    }

    elementList = req.responseXML.getElementsByTagName("info");

    for (idx = 0; idx < elementList.length; idx++) {
        element = elementList.item(idx);
        nameText  = element.getElementsByTagName("name").item(0).firstChild.nodeValue;
        valueNode = element.getElementsByTagName("value").item(0).firstChild;

        if (valueNode != null) {
            valueText = valueNode.nodeValue;

            row = document.createElement("TR");

            cell = document.createElement("TD");
            cell.setAttribute("width", "40%");
            cell.setAttribute("align", "right");
            cell.setAttribute("class", "rating");
            textNode = document.createTextNode(nameText + ":");
            cell.appendChild(textNode);
            row.appendChild(cell);

            cell = document.createElement("TD");
            cell.innerHTML = "&nbsp;" + valueText;
            row.appendChild(cell);

            infoTable.appendChild(row);
        }
    }

    websiteUrl = getNodeText("website");

    if (websiteUrl != null) {
        websiteText = new String(websiteUrl);
        if (websiteText.length > MAX_URL_CHARS_PER_WIDTH) {
            websiteText = helpWrapUrlString(websiteText);
        }

        row = document.createElement("TR");
        cell = document.createElement("TD");
        cell.setAttribute("colspan", "2");
        cell.setAttribute("style", "text-align:center;");
        aTag = document.createElement("A");
        aTag.setAttribute("onClick", "widget.openURL('" + websiteUrl + "');return false;");
        aTag.setAttribute("href", "");
        textNode = document.createTextNode(websiteText);
        aTag.appendChild(textNode);
        cell.appendChild(aTag);
        row.appendChild(cell);
        infoTable.appendChild(row);
    }

    row = document.createElement("TR");
    cell = document.createElement("TD");
    cell.setAttribute("colspan", "2");
    cell.innerHTML = "<HR id='horizRule' size='1' width='95%'>";
    row.appendChild(cell);
    infoTable.appendChild(row);
}

function buildCommentsTable() {
    var row;
    var cell;
    var textNode;
    var elementList;
    var element;
    var idx;
    var jdx;
    var ratingNode;
    var ratingText;
    var ratingCatTable;
    var rcRow;
    var ratingCatVals;
    var ratingVal;
    var dateNode;
    var rcDate;

    var commentsTable = document.getElementById("commentsTable");
    clearTable(commentsTable);

    elementList = req.responseXML.getElementsByTagName("rating");

    for (idx = 0; idx < elementList.length; idx++) {
        element = elementList.item(idx);
        ratingNode = element.getElementsByTagName("ratingText").item(0).firstChild;

        if (ratingNode != null) {
            ratingText = ratingNode.nodeValue;

            row = document.createElement("TR");
            if ((idx % 2) == 1) {
                row.setAttribute("bgcolor", GREEN_BKG_COLOR);
            }

            ratingCatTable = document.createElement("TABLE");
            ratingCatTable.setAttribute("width", "100%");
            ratingCatTable.setAttribute("border", "0");
            ratingCatTable.setAttribute("cellspacing", "0");
            ratingCatTable.setAttribute("cellpadding", "1");

            rcRow = document.createElement("TR");

            ratingCatVals = element.getElementsByTagName("ratingCatValue");

            for (jdx = 0; jdx < ratingCatVals.length; jdx++) {
                ratingVal = ratingCatVals.item(jdx).firstChild.nodeValue;
                cell = document.createElement("TD");
                cell.setAttribute("class", "rating");
                textNode = document.createTextNode(RATINGS_CAT_LABELS[jdx] + ":" + ratingVal);
                cell.appendChild(textNode);
                rcRow.appendChild(cell);

                //cell = document.createElement("TD");
                //textNode = document.createTextNode("|");
                //cell.appendChild(textNode);
                //rcRow.appendChild(cell);
            }

            dateNode = element.getElementsByTagName("date");
            if (dateNode != null) {
                rcDate = dateNode.item(0).firstChild;
                if (rcDate != null) {
                    cell = document.createElement("TD");
                    textNode = document.createTextNode(rcDate.nodeValue);
                    cell.appendChild(textNode);
                    rcRow.appendChild(cell);
                }
            }
            ratingCatTable.appendChild(rcRow);

            cell = document.createElement("TD");
            cell.appendChild(ratingCatTable);
            row.appendChild(cell);
            commentsTable.appendChild(row);

            row = document.createElement("TR");
            if ((idx % 2) == 1) {
                row.setAttribute("bgcolor", GREEN_BKG_COLOR);
            }
            cell = document.createElement("TD");
            cell.innerHTML = ratingText;
            row.appendChild(cell);
            commentsTable.appendChild(row);
        }
    }
}

function helpWrapUrlString(str) {
    var start = Math.floor(str.length / 2);

    for (var idx = start; idx < str.length; idx++) {
        if (str.charAt(idx) == "/") {
            return str.substring(0, idx+1) + " " + str.substr(idx+1);
        }
    }
    return str;
}

// Get the text for the node of the specified name. This function handles
// all the intermediate checking for null things and returns a null if any
// of them are null.
function getNodeText(nodeName) {
    var theTag = req.responseXML.getElementsByTagName(nodeName);

    if (theTag == null) {
        return null;
    } else {
        var theNode = theTag.item(0);
        if (theNode == null) {
            return null;
        } else {
            return theNode.firstChild.nodeValue;
        }
    }
}

function findPosY(obj) {
    var curtop = 0;
    if (obj.offsetParent) {
        while (obj.offsetParent) {
            curtop += obj.offsetTop;
            obj = obj.offsetParent;
        }
    } else if (obj.y) {
        curtop += obj.y;
    }
    return curtop;
}


/**** Back side and flip code (from Apple) ****/

function showBack() {
    var front = document.getElementById("front");
    var back  = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }
    front.style.display = "none";
    back.style.display  = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

function hideBack() {
    var front = document.getElementById("front");
    var back  = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }
    back.style.display  = "none";
    front.style.display = "block";
    exitflip();

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove(event) {
    if (!flipShown) {
        if (animation.timer != null) {
            clearInterval(animation.timer);
            animation.timer = null;
        }
        var starttime = (new Date).getTime() - 13;
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById('flip');
        animation.timer = setInterval("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit(event) {
    if (flipShown) {
        // fade in the info button
        if (animation.timer != null) {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
        var starttime = (new Date).getTime() - 13;
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById('flip');
        animation.timer = setInterval("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function animate() {
    var T;
    var ease;
    var time = (new Date).getTime();
    T = limit_3(time-animation.starttime, 0, animation.duration);
    if (T >= animation.duration) {
        clearInterval(animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    } else {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat(animation.from, animation.to, ease);
    }
 animation.firstElement.style.opacity = animation.now;
}

function limit_3(a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease) {
    return from + (to - from) * ease;
}

function enterflip(event) {
    document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
    document.getElementById('fliprollie').style.display = 'none';
    return;
}